﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using MovieCharacters;

namespace MovieCharacters.Migrations
{
    [DbContext(typeof(MovieCharacterDbContext))]
    [Migration("20220304102027_fi")]
    partial class fi
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("ProductVersion", "5.0.14")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("MovieCharacters.Models.Character", b =>
                {
                    b.Property<int>("characterId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("alias")
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("characterName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("characterPicture")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("gender")
                        .IsRequired()
                        .HasMaxLength(6)
                        .HasColumnType("nvarchar(6)");

                    b.HasKey("characterId");

                    b.ToTable("character");

                    b.HasData(
                        new
                        {
                            characterId = 1,
                            alias = "Mr.Anderson",
                            characterName = "Neo",
                            characterPicture = "https://upload.wikimedia.org/wikipedia/en/c/c6/NeoTheMatrix.jpg",
                            gender = "male"
                        },
                        new
                        {
                            characterId = 2,
                            alias = "Iron Man",
                            characterName = "Tony Stark",
                            characterPicture = "https://upload.wikimedia.org/wikipedia/en/f/f2/Robert_Downey_Jr._as_Tony_Stark_in_Avengers_Infinity_War.jpg",
                            gender = "male"
                        },
                        new
                        {
                            characterId = 3,
                            characterName = "Pepper Potts",
                            characterPicture = "https://static.wikia.nocookie.net/disney/images/5/56/Pepper_Potts.jpg/revision/latest?cb=20181223155649",
                            gender = "female"
                        },
                        new
                        {
                            characterId = 4,
                            alias = "Captain America",
                            characterName = "Steve Rogers",
                            characterPicture = "https://upload.wikimedia.org/wikipedia/en/6/6b/Chris_Evans_as_Steve_Rogers_Captain_America.jpg",
                            gender = "male"
                        },
                        new
                        {
                            characterId = 5,
                            alias = "Black Widow",
                            characterName = "Natasha Romanoff",
                            characterPicture = "https://upload.wikimedia.org/wikipedia/en/f/f6/Scarlett_Johansson_as_Black_Widow.jpg",
                            gender = "female"
                        });
                });

            modelBuilder.Entity("MovieCharacters.Models.Franchise", b =>
                {
                    b.Property<int>("franchiseId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("description")
                        .IsRequired()
                        .HasMaxLength(140)
                        .HasColumnType("nvarchar(140)");

                    b.Property<string>("franchiseName")
                        .IsRequired()
                        .HasMaxLength(25)
                        .HasColumnType("nvarchar(25)");

                    b.HasKey("franchiseId");

                    b.ToTable("franchise");

                    b.HasData(
                        new
                        {
                            franchiseId = 1,
                            description = "Harry Potter is a wizard",
                            franchiseName = "Harry Potter"
                        },
                        new
                        {
                            franchiseId = 2,
                            description = "Superheroes saving the world aka America",
                            franchiseName = "Marvel Cinematic Universe"
                        },
                        new
                        {
                            franchiseId = 3,
                            description = "We're living in a simulation",
                            franchiseName = "Matrix"
                        });
                });

            modelBuilder.Entity("MovieCharacters.Models.Movie", b =>
                {
                    b.Property<int>("movieId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("director")
                        .IsRequired()
                        .HasMaxLength(30)
                        .HasColumnType("nvarchar(30)");

                    b.Property<int?>("franchiseId")
                        .HasColumnType("int");

                    b.Property<string>("genre")
                        .IsRequired()
                        .HasMaxLength(75)
                        .HasColumnType("nvarchar(75)");

                    b.Property<string>("moviePicture")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("movieTitle")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<string>("releaseYear")
                        .IsRequired()
                        .HasMaxLength(4)
                        .HasColumnType("nvarchar(4)");

                    b.Property<string>("trailerUrl")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("movieId");

                    b.HasIndex("franchiseId");

                    b.ToTable("movie");

                    b.HasData(
                        new
                        {
                            movieId = 1,
                            director = "Alfonso Cuarón",
                            franchiseId = 1,
                            genre = "Fantasy, Adventure",
                            moviePicture = "https://m.media-amazon.com/images/M/MV5BMTY4NTIwODg0N15BMl5BanBnXkFtZTcwOTc0MjEzMw@@._V1_FMjpg_UX1000_.jpg",
                            movieTitle = "Harry Potter and the Prisoner of Azkaban",
                            releaseYear = "2004",
                            trailerUrl = "https://www.youtube.com/watch?v=lAxgztbYDbs"
                        },
                        new
                        {
                            movieId = 2,
                            director = "John Favreau",
                            franchiseId = 2,
                            genre = "Action, Adventure",
                            moviePicture = "https://upload.wikimedia.org/wikipedia/en/0/02/Iron_Man_%282008_film%29_poster.jpg",
                            movieTitle = "Ironman",
                            releaseYear = "2008",
                            trailerUrl = "https://www.youtube.com/watch?v=8ugaeA-nMTc"
                        },
                        new
                        {
                            movieId = 3,
                            director = "Wachowski sisters",
                            franchiseId = 3,
                            genre = "Science-Fiction, Action",
                            moviePicture = "https://m.media-amazon.com/images/M/MV5BNzQzOTk3OTAtNDQ0Zi00ZTVkLWI0MTEtMDllZjNkYzNjNTc4L2ltYWdlXkEyXkFqcGdeQXVyNjU0OTQ0OTY@._V1_.jpg",
                            movieTitle = "Matrix",
                            releaseYear = "1999",
                            trailerUrl = "https://www.youtube.com/watch?v=vKQi3bBA1y8"
                        },
                        new
                        {
                            movieId = 4,
                            director = "Wachowski sisters",
                            franchiseId = 3,
                            genre = "Science-Fiction, Action",
                            moviePicture = "https://m.media-amazon.com/images/M/MV5BODE0MzZhZTgtYzkwYi00YmI5LThlZWYtOWRmNWE5ODk0NzMxXkEyXkFqcGdeQXVyNjU0OTQ0OTY@._V1_.jpg",
                            movieTitle = "The Matrix Reloaded",
                            releaseYear = "2003",
                            trailerUrl = "https://www.youtube.com/watch?v=kYzz0FSgpSU"
                        },
                        new
                        {
                            movieId = 5,
                            director = "Chris Columbus",
                            genre = "Fantasy, Adventure",
                            moviePicture = "https://m.media-amazon.com/images/M/MV5BMTcxODgwMDkxNV5BMl5BanBnXkFtZTYwMDk2MDg3._V1_FMjpg_UX1000_.jpg",
                            movieTitle = "Harry Potter and the chamber of secrets",
                            releaseYear = "2002",
                            trailerUrl = "https://www.youtube.com/watch?v=1bq0qff4iF8"
                        },
                        new
                        {
                            movieId = 6,
                            director = "David Yates",
                            genre = "Fantasy, Adventure",
                            moviePicture = "https://m.media-amazon.com/images/M/MV5BNzU3NDg4NTAyNV5BMl5BanBnXkFtZTcwOTg2ODg1Mg@@._V1_.jpg",
                            movieTitle = "Harry Potter and the half blood prince",
                            releaseYear = "2009",
                            trailerUrl = "https://www.youtube.com/watch?v=JYLdTuL9Wjw"
                        });
                });

            modelBuilder.Entity("Starring", b =>
                {
                    b.Property<int>("movieId")
                        .HasColumnType("int");

                    b.Property<int>("characterId")
                        .HasColumnType("int");

                    b.HasKey("movieId", "characterId");

                    b.HasIndex("characterId");

                    b.ToTable("Starring");

                    b.HasData(
                        new
                        {
                            movieId = 2,
                            characterId = 2
                        },
                        new
                        {
                            movieId = 2,
                            characterId = 3
                        },
                        new
                        {
                            movieId = 3,
                            characterId = 1
                        },
                        new
                        {
                            movieId = 4,
                            characterId = 1
                        });
                });

            modelBuilder.Entity("MovieCharacters.Models.Movie", b =>
                {
                    b.HasOne("MovieCharacters.Models.Franchise", "franchise")
                        .WithMany("movies")
                        .HasForeignKey("franchiseId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.Navigation("franchise");
                });

            modelBuilder.Entity("Starring", b =>
                {
                    b.HasOne("MovieCharacters.Models.Character", null)
                        .WithMany()
                        .HasForeignKey("characterId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("MovieCharacters.Models.Movie", null)
                        .WithMany()
                        .HasForeignKey("movieId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("MovieCharacters.Models.Franchise", b =>
                {
                    b.Navigation("movies");
                });
#pragma warning restore 612, 618
        }
    }
}
